package com.engine.organization.job;

import com.engine.organization.entity.column.TableColumnPO;
import com.engine.organization.mapper.danikor.DanikorResourceMapper;
import com.engine.organization.mapper.extend.ExtendInfoMapper;
import com.engine.organization.util.db.MapperProxyFactory;
import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 同步用户数据定时服务
 *
 * @author:dxfeng
 * @createTime: 2023/01/16
 * @version: 1.0
 */
public class DanikorSyncUserJob extends BaseCronJob {

     //select * into hrmresource_back FROM hrmresource where 1=2;
     //alter table hrmresource_back add sync_date date null;
     //alter table hrmresource_back add default getdate() for sync_date;
     //alter table hrmresource_back add sync_id int identity(1,1);
    private static final String RESOURCE_MAIN = "hrmresource";
    private static final String RESOURCE_BACK = "hrmresource_back";

     //CREATE TABLE cus_fielddata_back (
     //seqorder int NOT NULL,
     //[scope] varchar(1000) NULL,
     //scopeid int NOT NULL,
     //id int NOT NULL,
     //sync_date date null,
     //sync_id int identity(1,1)
     //);
     //alter table cus_fielddata_back add default getdate() for sync_date;
    private static final String CUS_MAIN = "cus_fielddata";
    private static final String CUS_BACK = "cus_fielddata_back";

     //select * into hrmsubcompany_back FROM hrmsubcompany where 1=2;
     //alter table hrmsubcompany_back add sync_date date null;
     //alter table hrmsubcompany_back add default getdate() for sync_date;
     //alter table hrmsubcompany_back drop column id;
     //alter table hrmsubcompany_back add id int not null;
     //alter table hrmsubcompany_back add sync_id int identity(1,1);
    private static final String COMPANY_MAIN = "hrmsubcompany";
    private static final String COMPANY_BACK = "hrmsubcompany_back";

     //CREATE TABLE hrmsubcompanydefined_back (
     //id int NOT NULL,
     //subcomid int NOT NULL,
     //sync_date date null,
     //sync_id int identity(1,1)
     //);
     //alter table hrmsubcompanydefined_back add default getdate() for sync_date;
    private static final String COMPANY_DEFINED_MAIN = "hrmsubcompanydefined";
    private static final String COMPANY_DEFINED_BACK = "hrmsubcompanydefined_back";

    //select * into hrmdepartment_back FROM hrmdepartment where 1=2;
    //alter table hrmdepartment_back add sync_date date null;
    //alter table hrmdepartment_back add default getdate() for sync_date;
    //alter table hrmdepartment_back drop column id;
    //alter table hrmdepartment_back add id int not null;
    //alter table hrmdepartment_back add sync_id int identity(1,1);
    private static final String DEPARTMENT_MAIN = "hrmdepartment";
    private static final String DEPARTMENT_BACK = "hrmdepartment_back";

    //CREATE TABLE hrmdepartmentdefined_back (
    //id int NOT NULL,
    //deptid int NOT NULL,
    //sync_date date null,
    //sync_id int identity(1,1)
    //);
    //alter table hrmdepartmentdefined_back add default getdate() for sync_date;
    private static final String DEPARTMENT_DEFINED_MAIN = "hrmdepartmentdefined";
    private static final String DEPARTMENT_DEFINED_BACK = "hrmdepartmentdefined_back";

    private DanikorResourceMapper getDanikorResourceMapper() {
        return MapperProxyFactory.getProxy(DanikorResourceMapper.class);
    }

    @Override
    public void execute() {
        // 比较两张表的表结构,同步表结构、表数据
        syncTableFields(RESOURCE_MAIN, RESOURCE_BACK);
        syncTableFields(CUS_MAIN, CUS_BACK);

        syncTableFields(COMPANY_MAIN, COMPANY_BACK);
        syncTableFields(COMPANY_DEFINED_MAIN, COMPANY_DEFINED_BACK);

        syncTableFields(DEPARTMENT_MAIN, DEPARTMENT_BACK);
        syncTableFields(DEPARTMENT_DEFINED_MAIN, DEPARTMENT_DEFINED_BACK);
    }


    /**
     * 同步表字段
     *
     * @param mainTableName
     * @param backTableName
     */
    private void syncTableFields(String mainTableName, String backTableName) {
        List<TableColumnPO> mainTableFields;
        List<TableColumnPO> backTableFields;
        if (CUS_MAIN.equals(mainTableName)) {
            mainTableFields = getDanikorResourceMapper().getCusColumnByTableName(mainTableName);
            backTableFields = getDanikorResourceMapper().getCusColumnByTableName(backTableName);
        } else {
            mainTableFields = getDanikorResourceMapper().getHrmColumnByTableName(mainTableName);
            backTableFields = getDanikorResourceMapper().getHrmColumnByTableName(backTableName);
        }
        for (TableColumnPO tableColumnPO : mainTableFields) {
            if (!backTableFields.contains(tableColumnPO)) {
                // 为回溯表创建字段
                MapperProxyFactory.getProxy(ExtendInfoMapper.class).addTableColumn(backTableName, tableColumnPO.getColumnName(), tableColumnPO.getColumnType());
            }
        }
        RecordSet rs = new RecordSet();
        String mainTableColumns = mainTableFields.stream().map(TableColumnPO::getColumnName).collect(Collectors.joining(","));
        // 同步主表数据
        String sql = "insert into " + backTableName + "(" + mainTableColumns + ") select " + mainTableColumns + " from " + mainTableName;
        rs.execute(sql);
    }
}
