package com.engine.organization.wrapper;

import com.engine.common.util.ServiceUtil;
import com.engine.organization.entity.danikor.param.ChartParam;
import com.engine.organization.service.DanikorResourceBackService;
import com.engine.organization.service.impl.DanikorResourceBackServiceImpl;
import com.engine.organization.util.MenuBtn;
import com.engine.organization.util.OrganizationWrapper;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2023/01/28
 * @version: 1.0
 */
public class DanikorResourceBackWrapper extends OrganizationWrapper {

    private DanikorResourceBackService getDanikorResourceBackService(User user) {
        return ServiceUtil.getService(DanikorResourceBackServiceImpl.class, user);
    }

    public Map<String, Object> listPage(Map<String, Object> params) {
        return getDanikorResourceBackService(user).listPage(params);
    }

    public Map<String, Object> getSearchCondition() {
        return getDanikorResourceBackService(user).getSearchCondition();
    }

    public Map<String, List<MenuBtn>> getHasRight() {
        return getDanikorResourceBackService(user).getHasRight();
    }

    public Map<String, Object> getSummaryData(Map<String, Object> params) {
        return getDanikorResourceBackService(user).getSummaryData(params);
    }

    public String getOrgChartData(HttpServletRequest request, Map<String, Object> params) {
        return getDanikorResourceBackService(user).getOrgChartData(request, params);
    }

    public List<ChartParam> getResourceChartData(Map<String, Object> params) {
        return getDanikorResourceBackService(user).getResourceChartData(params);
    }
}
